.Const

.Data

HYPERLINK_MESSAGES	DD WM_CREATE, OnHyperLinkCreate
					DD WM_COMMAND, OnHyperLinkCommand
					DD WM_CLOSE, OnHyperLinkClose
					DD WM_DESTROY, OnHyperLinkDestroy

lpszBuffer			DD NULL


.Code

HyperLinkProcedure Frame hWnd, uMsg, wParam, lParam
	Mov Eax, [uMsg]
	Mov Ecx, SizeOf HYPERLINK_MESSAGES / 8
	Mov Edx, Addr HYPERLINK_MESSAGES
:	Dec Ecx
	Js > L2
	Cmp [Edx + Ecx * 8], Eax
	Jne <
	Call [Edx + Ecx * 8 + 4]
	Ret
L2:	Xor Eax, Eax	;Return (FALSE)
	Ret
EndF

OnHyperLinkCreate: UseData HyperLinkProcedure
	;==================================
	;Write the initialization code here
	;==================================
	Invoke GlobalAlloc, GPTR, 1024
	Mov [lpszBuffer], Eax
	Xor Eax, Eax	;Return (FALSE)
	Ret
EndU

OnHyperLinkCommand: UseData HyperLinkProcedure
	LoWord ([wParam])
	Cmp Ax, IDC_HYPERLINK_BTNCLOSE
	Jne >
	HiWord ([wParam])
	Cmp Ax, BN_CLICKED
	Jne >
	Invoke SendMessage, [hWnd], WM_CLOSE, 0, 0
	Mov Eax, TRUE
	Ret
:	Xor Eax, Eax	;Return (FALSE)
	Ret
EndU

OnHyperLinkClose: UseData HyperLinkProcedure
	;=========================
	;Write the final code here
	;=========================
	Invoke IsModal, [hWnd]
	Or Eax, Eax		;Cmp Eax, FALSE
	Jz >
	Invoke EndModal, [hWnd], IDCANCEL
	Mov Eax, TRUE	;Return (TRUE)
:	Ret
EndU

OnHyperLinkDestroy: UseData HyperLinkProcedure
	Invoke GlobalFree, [lpszBuffer]
	Xor Eax, Eax	;Return (FALSE)
	Ret
EndU

HyperLinkstcMail Frame hWnd, uMsg, wParam, lParam
	Cmp D[uMsg], ECM_LINKPUSHED
	Jne >
	Invoke SetWaitCursor, [hWnd]
	Invoke lstrcpy, [lpszBuffer], TEXT("mailto:")
	Invoke lstrcat, [lpszBuffer], [lParam]
	Invoke GetParent, [hWnd]
	Invoke ShellExecute, Eax, NULL, [lpszBuffer], NULL, NULL, SW_SHOWNORMAL
	Invoke SetDefaultCursor
	Mov Eax, TRUE	;Return (TRUE)
	Ret
:	Xor Eax, Eax	;Return (FALSE)
	Ret
EndF

HyperLinkstcWeb Frame hWnd, uMsg, wParam, lParam
	Cmp D[uMsg], ECM_LINKPUSHED
	Jne >
	Invoke SetWaitCursor, [hWnd]
	Invoke lstrcpy, [lpszBuffer], [lParam]
	Invoke GetParent, [hWnd]
	Invoke ShellExecute, Eax, NULL, [lParam], NULL, NULL, SW_SHOWNORMAL
	Invoke SetDefaultCursor
	Mov Eax, TRUE	;Return (TRUE)
	Ret
:	Xor Eax, Eax	;Return (FALSE)
	Ret
EndF
